from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, Float, Boolean, Directory

Isoncorrect_V0_1_0 = CommandToolBuilder(tool="isONcorrect", base_command=["isONcorrect"], inputs=[ToolInput(tag="in_fast_q", input_type=File(optional=True), prefix="--fastq", doc=InputDocumentation(doc="Path to input fastq file with reads (default: False)")), ToolInput(tag="in_kmer_size_default", input_type=Int(optional=True), prefix="--k", doc=InputDocumentation(doc="Kmer size (default: 9)")), ToolInput(tag="in_window_size_default", input_type=Int(optional=True), prefix="--w", doc=InputDocumentation(doc="Window size (default: 20)")), ToolInput(tag="in_xmin", input_type=Int(optional=True), prefix="--xmin", doc=InputDocumentation(doc="Lower interval length (default: 18)")), ToolInput(tag="in_xmax", input_type=Int(optional=True), prefix="--xmax", doc=InputDocumentation(doc="Upper interval length (default: 80)")), ToolInput(tag="in_minimum_fraction_keeping", input_type=Float(optional=True), prefix="--T", doc=InputDocumentation(doc="Minimum fraction keeping substitution (default: 0.1)")), ToolInput(tag="in_exact", input_type=Boolean(optional=True), prefix="--exact", doc=InputDocumentation(doc="Get exact solution for WIS for evary read\n(recalculating weights for each read (much slower but\nslightly more accuracy, not to be used for clusters\nwith over ~500 reads) (default: False)")), ToolInput(tag="in_disable_numpy", input_type=Boolean(optional=True), prefix="--disable_numpy", doc=InputDocumentation(doc="Do not require numpy to be installed, but this version\nis about 1.5x slower than with numpy. (default: False)")), ToolInput(tag="in_max_seqs_to_spo_a", input_type=Int(optional=True), prefix="--max_seqs_to_spoa", doc=InputDocumentation(doc="Maximum number of seqs to spoa (default: 200)")), ToolInput(tag="in_max_seqs", input_type=Int(optional=True), prefix="--max_seqs", doc=InputDocumentation(doc="Maximum number of seqs to correct at a time (in case\nof large clusters). (default: 2000)")), ToolInput(tag="in_use_rac_on", input_type=Boolean(optional=True), prefix="--use_racon", doc=InputDocumentation(doc="Use racon to polish consensus after spoa (more time\nconsuming but higher accuracy). (default: False)")), ToolInput(tag="in_exact_instance_limit", input_type=Int(optional=True), prefix="--exact_instance_limit", doc=InputDocumentation(doc="Activates slower exact mode for instance smaller than\nthis limit (default: 0)")), ToolInput(tag="in_set_w_dynamically", input_type=Boolean(optional=True), prefix="--set_w_dynamically", doc=InputDocumentation(doc="Set w = k + max(2*k, floor(cluster_size/1000)).\n(default: False)")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Print various developer stats. (default: False)")), ToolInput(tag="in_rand_strobes", input_type=Boolean(optional=True), prefix="--randstrobes", doc=InputDocumentation(doc="EXPERIMENTAL PARAMETER: IsONcorrect uses paired\nminimizers (described in isONcorrect paper). This\nexperimental option uses randstrobes instead of paired\nminimizers to find shared regions. Randstrobes reduces\nmemory footprint substantially (and runtime) with only\nslight increase in post correction quality. (default:\nFalse)")), ToolInput(tag="in_layers", input_type=Int(optional=True), prefix="--layers", doc=InputDocumentation(doc="EXPERIMENTAL PARAMETER: Active when --randstrobes\nspecified. How many 'layers' with randstrobes we want\nper sequence to sample. More layers gives more\naccureate results but is more memory consuming and\nslower. It is not reccomended to specify more than 5.")), ToolInput(tag="in_set_layers_manually", input_type=Boolean(optional=True), prefix="--set_layers_manually", doc=InputDocumentation(doc="EXPERIMENTAL PARAMETER: By default isONcorrect sets\nlayers = 1 if nr seqs in batch to be corrected is >=\n1000, else layers = 2. This command will manually pick\nthe number of layers specified with the --layers\nparameter. (default: False)")), ToolInput(tag="in_compression", input_type=Boolean(optional=True), prefix="--compression", doc=InputDocumentation(doc="Use homopolymenr compressed reads. (Deprecated,\nbecause we will have fewer minmimizer combinations to\nspan regions in homopolymenr dense regions. Solution\ncould be to adjust upper interval legnth dynamically\nto guarantee a certain number of spanning intervals.\n(default: False)")), ToolInput(tag="in_out_folder", input_type=Directory(optional=True), prefix="--outfolder", doc=InputDocumentation(doc="A fasta file with transcripts that are shared between\nsamples and have perfect illumina support. (default:\nNone)\n"))], outputs=[ToolOutput(tag="out_out_folder", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_out_folder", type_hint=File()), doc=OutputDocumentation(doc="A fasta file with transcripts that are shared between\nsamples and have perfect illumina support. (default:\nNone)\n"))], container="quay.io/biocontainers/isoncorrect:0.0.8--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Isoncorrect_V0_1_0().translate("wdl")

